# 32/64bit spec-file
#
Name:           kde4-config-fm
Version:        4.10
Release:        %mkrel 1
License:        GNU General Public License (GPL)
URL:            http://www.pclinuxos.com/forum/index.php/topic,73118.msg599294.html
Source:         %{name}-%{version}.tar.xz
Source1:        skel_fm.tar.xz
Source2:        skel_default.tar.xz
Summary:        KDE FullMonty desktop layout
Group:          Graphics
Requires:	kde-smooth-tasks plasma-applet-devicemanager wallpaper-theme-default
Conflicts:	kde4-config-legacy kde4-config libcompiz0 libcompizconfig0 libcompizconfig-python 
Conflicts:	ccsm plasma-applet-takeoff fullmonty-light
Provides:	FullMonty_light = %version-%release
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:      noarch

%description
The following information is also available in the Home directory of any FullMonty user account.

The PCLinuxOS KDE4 FullMonty desktop provides 6 activity-focused virtual desktops to address typical user-needs: 
1) Internet: email, internet, chat, instant messaging, file sharing, etc.
2) Office: OpenOffice, calculator, financing, etc.
3) Games: some games... 
4) MultiMedia: convert music, watch/make DVDs, etc. 
5) Graphics: applications for working with images and photos, post-process, draw, etc. 
6) System: system info, administration, configuration, etc. 

The following 3 FullMonty tools are included:
1) fm_info: provide basic information about the FullMonty base installation and your system.
2) fm_setwidgets: select one of 12 pre-configured plasma config-files to either match your screen-resolution or to restore a pre-defined FullMonty-desktop layout. This tools can also be used to unlock and then personalize your current desktop layout or to adapt it to a non pre-configured screen-resolution. 
3) fm_switcher: switch between the FullMonty and the default PCLinuxOS KDE desktop layout which is then applied to any new user on the system.

NOTE: each of the 6 virtual desktops has containers with application launchers. If you uninstall one of these applications then the respective launcher will show a question mark. 
To delete any unwanted application launcher point your mouse over it and rightclick -> Delete). 
To add a new application launcher, follow these steps:
a) rightclick inside the folder view container on your virtual desktop and select: Create New -> Basic link to file or directory
b) In the second field of the Plasma Workspace window: browse to /usr/share/applications/(kde4) and select the application launcher (.desktop file) you want to add
c) In the first field of the Plasma Workspace window: rename the application launcher to your liking, then press OK.

Creating or placing a file on the desktop background will make it available on all 6 virtual desktops. If you do not like this you should place your files in your home folder or one of its sub-directories.


More FullMonty related information can be found in the PCLinuxOS forum:
http://www.pclinuxos.com/forum/index.php/topic,73118.0.html

# steps to do before the installation: restore the original state!
#==================================================================
%pre
# test for FM directories and if found remove all of FM to start afresh
if [ -d %{_sysconfdir}/skelprefm ];then
  rm -fR %{_sysconfdir}/{skel,skel_fm,skel_default}
else
  # backup original skel to be restored upon uninstallation of FM
  mv %{_sysconfdir}/skel %{_sysconfdir}/skelprefm
fi


%prep 

%setup -q

%build

%install
rm -rf %{buildroot}
# add fm_switcher and fm_info script
install -D -m 755 fm_switcher %{buildroot}/%{_bindir}/fm_switcher

# define desktop files for fm_switcher, fm_setwidgets, fm_info, krunner, kwritesu
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/applications/kde4
cat > $RPM_BUILD_ROOT%{_datadir}/applications/fm_switcher.desktop << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=Fullmonty/Default Layout Switcher
Exec=fm_switcher
Icon=/usr/share/icons/oxygen/32x32/actions/format-connect-node.png
Categories=System;X-MandrivaLinux-System-Configuration;
Terminal=false
Encoding=UTF-8
StartupNotify=true
OnlyShowIn=KDE
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/fm_setwidgets.desktop << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=Fullmonty Widgets Setup
Exec=~/.kde4/vdt/fm_setwidgets
Icon=/usr/share/icons/oxygen/32x32/actions/format-connect-node.png
Categories=System;X-MandrivaLinux-System-Configuration;Settings;
Terminal=false
Encoding=UTF-8
StartupNotify=true
OnlyShowIn=KDE
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/fm_info.desktop << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=Fullmonty Information
Exec=~/.kde4/vdt/fm_info
Icon=/usr/share/icons/fm.png
Categories=System;X-MandrivaLinux-System-Configuration;Settings;
Terminal=false
Encoding=UTF-8
StartupNotify=true
OnlyShowIn=KDE
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/kde4/krunner.desktop << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=krunner
Exec=krunner
Icon=system-run
Categories=Qt;KDE;System;Monitor;X-MandrivaLinux-System-Monitoring;
X-DocPath=krunner/index.html
Comment=Run command
Terminal=false
GenericName=Run command
Encoding=UTF-8
X-Desktop-File-Install-Version=0.11
OnlyShowIn=KDE
EOF


cat > $RPM_BUILD_ROOT%{_datadir}/applications/kde4/kwritesu.desktop << EOF
[Desktop Entry]
Version=1.0
Type=Application
Name=KWrite - Super User Mode
MimeType=text/plain;
Exec=kwrite %U
X-KDE-StartupNotify=true
X-KDE-SubstituteUID=true
Icon=accessories-text-editor
X-DocPath=kwrite/index.html
InitialPreference=8
X-DBUS-ServiceName=org.kate-editor.kwrite
Categories=Qt;KDE;Utility;TextEditor;X-MandrivaLinux-MoreApplications-Editors;
X-Desktop-File-Install-Version=0.11
Terminal=false
Encoding=UTF-8
OnlyShowIn=KDE
EOF


cat > $RPM_BUILD_ROOT%{_datadir}/applications/ForumHelp.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Type=Application
Name=Forum Help
Comment=Get forum help
Icon=/usr/share/pixmaps/forumhelp.png
Exec=firefox http://www.pclinuxos.com/forum/
Categories=X-MandrivaLinux-Internet-Other;X-MandrivaLinux-MoreApplications-Documentation;
Terminal=false
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/FirstSteps.desktop << EOF
[Desktop Entry]
Categories=Network;X-MandrivaLinux-Internet-Other;X-MandrivaLinux-MoreApplications-Documentation;
Comment[en_US]=Info to get you started
Comment=Info to get you started
Encoding=UTF-8
Exec=xdg-open /usr/share/doc/HTML/firststeps/firststeps
Icon=/usr/share/pixmaps/firststeps.png
Name=First Steps
StartupNotify=true
Terminal=false
Type=Application
EOF

# the FM wallpapers and icons
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/wallpapers/{fm43,fm161,fm169}
cp fm43/*.jpg $RPM_BUILD_ROOT/%{_datadir}/wallpapers/fm43/
cp fm161/*.jpg $RPM_BUILD_ROOT/%{_datadir}/wallpapers/fm161/
cp fm169/*.jpg $RPM_BUILD_ROOT/%{_datadir}/wallpapers/fm169/
cp pclinuxos-dna.jpg $RPM_BUILD_ROOT/%{_datadir}/wallpapers/
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/doc/HTML/firststeps
cp firststeps/* $RPM_BUILD_ROOT/%{_datadir}/doc/HTML/firststeps/
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons
cp fm.png $RPM_BUILD_ROOT/%{_datadir}/icons/fm.png
cp FullMonty.png $RPM_BUILD_ROOT/%{_datadir}/icons/FullMonty.png
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/pixmaps
cp forumhelp.png $RPM_BUILD_ROOT/%{_datadir}/pixmaps/
cp firststeps.png $RPM_BUILD_ROOT/%{_datadir}/pixmaps/

# add the skel directories for FM and the default one
mkdir -p %{buildroot}%{_sysconfdir}
cp -f %{SOURCE1} %{buildroot}%{_sysconfdir}
cp -f %{SOURCE2} %{buildroot}%{_sysconfdir}

#=======================================
# steps to do after uninstalling of old package: reset to original skel and delete FM wallpapers
#=======================================
%postun
# reset only upon normal uninstall but not upon upgrade
if [ $1 == 0 ] ; then  
  # uninstall
  # add back enlightenment if present
  if [ -d %{_sysconfdir}/skel/.e ];then
    mkdir -p %{_sysconfdir}/skelprefm/.e
    cp -fR %{_sysconfdir}/skel/.e/* %{_sysconfdir}/skelprefm/.e/ 
    cp -fR %{_sysconfdir}/skel/.e/.??* %{_sysconfdir}/skelprefm/.e/ 
  fi
  # add addlocale modified files
  # e17 + addlocale?
  if [ -f %{_sysconfdir}/skel/addlocale_Enlightenment_Info.txt ]; then
    cp -f %{_sysconfdir}/skel/addlocale_Enlightenment_Info.txt %{_sysconfdir}/skelprefm/ 
  fi
  if [ -f %{_sysconfdir}/sysconfig/i18n_AL ]; then
    cp -f %{_sysconfdir}/skel/.bash_profile %{_sysconfdir}/skelprefm/
  fi
  if [ -f %{_sysconfdir}/skel/.kde4/Autostart/postaddlocale ];then
   cp -f %{_sysconfdir}/skel/.kde4/Autostart/postaddlocale %{_sysconfdir}/skelprefm/.kde4/Autostart/ 
  fi
  if [ -f %{_sysconfdir}/skel/LibreOffice_Info.txt ];then
    cp -f %{_sysconfdir}/skel/LibreOffice_Info.txt %{_sysconfdir}/skelprefm/ 
  fi
  # remove old stuff and restore skel from pre-fm install
  rm -fR %{_sysconfdir}/{skel,skel_fm,skel_default}
  mv %{_sysconfdir}/skelprefm %{_sysconfdir}/skel
elif [ $1 == 1 ]; then 
  # upgrade
  rm -fR %{_sysconfdir}/{skel,skel_fm,skel_default}
fi

#=======================================
# steps to do after the transaction
#=======================================
%posttrans
# extract the new skels set skel_fm to default
# we do this after the transaction (posttrans) because an uninstall of another kde4-config
# will mess up ours
pushd /etc
tar xfJ skel_fm.tar.xz
tar xfJ skel_default.tar.xz
rm -f skel_fm.tar.xz skel_default.tar.xz
chown -R root:root skel*
popd
ln -s %{_sysconfdir}/skel_fm %{_sysconfdir}/skel

# check if FM-full then add back karaoke directory
if [ -d %{_sysconfdir}/skelprefm/.kde4/vdt/4/4a/karaoke ];then
  cp -fr %{_sysconfdir}/skelprefm/.kde4/vdt/4/4a/karaoke %{_sysconfdir}/skel_fm/.kde4/vdt/4/4a/
fi
# clean up old trash
rm -f /root/Desktop/Trash.desktop

# if [ $1 == 0 ] ; then  
  # install of package
  
  # add back enlightenment if present
  if [ -d %{_sysconfdir}/skelprefm/.e ];then
    mkdir -p %{_sysconfdir}/skel_fm/.e
    mkdir -p %{_sysconfdir}/skel_default/.e
    cp -fR %{_sysconfdir}/skelprefm/.e/* %{_sysconfdir}/skel_fm/.e/ 
    cp -fR %{_sysconfdir}/skelprefm/.e/.??* %{_sysconfdir}/skel_fm/.e/ 
    cp -fR %{_sysconfdir}/skelprefm/.e/* %{_sysconfdir}/skel_default/.e/
    cp -fR %{_sysconfdir}/skelprefm/.e/.??* %{_sysconfdir}/skel_default/.e/
  fi
  # add addlocale modified files
  # e17 + addlocale?
  if [ -f %{_sysconfdir}/skelprefm/addlocale_Enlightenment_Info.txt ]; then
    cp -f %{_sysconfdir}/skelprefm/addlocale_Enlightenment_Info.txt %{_sysconfdir}/skel_fm/ 
    cp -f %{_sysconfdir}/skelprefm/addlocale_Enlightenment_Info.txt %{_sysconfdir}/skel_default/
  fi
  if [ -f %{_sysconfdir}/sysconfig/i18n_AL ]; then
    cp -f %{_sysconfdir}/skelprefm/.bash_profile %{_sysconfdir}/skel_fm/
    cp -f %{_sysconfdir}/skelprefm/.bash_profile %{_sysconfdir}/skel_default/
  fi
  if [ -f %{_sysconfdir}/skelprefm/.kde4/Autostart/postaddlocale ];then
   cp -f %{_sysconfdir}/skelprefm/.kde4/Autostart/postaddlocale %{_sysconfdir}/skel_fm/.kde4/Autostart/ 
   cp -f %{_sysconfdir}/skelprefm/.kde4/Autostart/postaddlocale %{_sysconfdir}/skel_default/.kde4/Autostart/ 
  fi
  if [ -f %{_sysconfdir}/skelprefm/LibreOffice_Info.txt ];then
    cp -f %{_sysconfdir}/skelprefm/LibreOffice_Info.txt %{_sysconfdir}/skel_fm/ 
    cp -f %{_sysconfdir}/skelprefm/LibreOffice_Info.txt %{_sysconfdir}/skel_default/ 
  fi
#fi

# b) clean up tmp for user and root
SYSUSERS=$(grep [0-9][0-9][0-9]:.*/home /etc/passwd | grep -f /etc/shells | cut -d: -f1)
rm -rf /tmp/kde* /tmp/ksocket* /root/tmp/kde-root /root/tmp/ksocket* 
for idx in $SYSUSERS
 do INP1= rm -rf /home/$idx/tmp/kde*; done
for idx in $SYSUSERS
 do INP1= rm -rf /home/$idx/tmp/ksocket*; done
# reset su alias in existing accounts and skel
for idx in $SYSUSERS
 do INP1= sed -i '/^alias su=/d' /home/$idx/.bashrc; done

# f) fix desktop display in root-account
if [ -e /root/.kde4/share/config/plasma-desktop-appletsrc ]; then 
sed -i 's|url=desktop\:\/|url=file\:\/\/\/root\/Desktop|g' /root/.kde4/share/config/plasma-desktop-appletsrc
fi

# Inform users
echo "The KDE4 FullMonty desktop layout will be applied to any NEW user account."
echo "To switch between FullMonty and standard KDE desktop for new user accounts use 'fm_switcher'"



#=======================================
# files to add to the system
#=======================================
%files 
%defattr(-, root, root)
%{_bindir}/fm_switcher
%{_datadir}/applications/kde4/*
%{_datadir}/applications/*
%{_datadir}/wallpapers/fm43/*
%{_datadir}/wallpapers/fm161/*
%{_datadir}/wallpapers/fm169/*
%{_datadir}/doc/HTML/firststeps/*
%{_datadir}/wallpapers/pclinuxos-dna.jpg
%{_datadir}/icons/fm.png
%{_datadir}/icons/FullMonty.png
%{_datadir}/pixmaps/forumhelp.png
%{_datadir}/pixmaps/firststeps.png
%{_sysconfdir}/*

# Changes
#=======================================
%changelog
* Thu Mar 14 2013 pinoc <vogtpet at gmail.com> 4.10-1pclos2013
- 4.10

* Mon Jan 28 2013 pinoc <vogtpet at gmail.com> 4.9.5-1pclos2013
- 4.9.5
- updated to also work on non-kde installs
- fixed posttrans

* Thu Sep 06 2012 Neal <nealbrks0 at gmail dot com> 4.8.3-2pclos2012
- process

* Thu Sep 06 2012 Pinoc <vogtpet at gmail.com> 4.8.3-2pclos2012
- Changed Obsoletes to Conflicts for other kde4-configs

* Mon Sep 03 2012 Pinoc <vogtpet at gmail.com> 4.8.3-1pclos2012
- initial build
